import java.awt.Graphics;
import java.util.Random;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JPanel;
import javax.swing.JOptionPane;


public class Ball extends JPanel
{
    private static final int win_w=640;
    private static final int win_h=480;
    
    private float radius=100;// radius of the ball
    
    private float x=radius+50;
    private float y=radius+20;//center coordinates of the ball
    
    private float sx=4;
    private float sy=3;       //change in the coordinates(x and y)
    
    private static final int update_rate=30;//refresh of screen per second
    // Now constructor
    private Random r;
    private Color clr=Color.BLUE;
    
    public static final long serialVersionUID=100044556;
    
    public Ball()
    {
        r=new Random();
        setPreferredSize(new Dimension(win_w,win_h));//size of the panel is set to
        //the size of the window
         
    }
    
    public void setColor(Color c)
    {
        clr=c;
    }
    
    public Color getColor()
    {
        return clr;
    }
   
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.setColor(Color.BLACK);
        g.fillRect(0,0,win_w,win_h);
        g.setColor(getColor());
        g.fillOval((int)(x-radius),(int)(y-radius),(int)(2*radius),(int)(2*radius));
        g.setColor(Color.WHITE);
        String s=String.format("Position:[%3.0f,%3.0f]",x,y);
        g.drawString(s,20,40);
    }
    
    public void startBouncing()
    {
    	 Thread ballthread=new Thread(){
             public void run(){
                                 while(true)
                                 {
                                     x+=sx;
                                     y+=sy;
                                     //here we handle collision with the window walls
                                     //checking the horizontal collision
                                     if(x-radius<0)
                                     {  
                                         sx=-sx;//reverse the direction
                                         x=radius;
                                         setColor(new Color(r.nextInt(256),r.nextInt(256),r.nextInt(256)));
                                       
                                     }
                                     else if(x+radius>win_w)
                                     {
                                         sx=-sx;
                                         x=win_w-radius;
                                         setColor(new Color(r.nextInt(256),r.nextInt(256),r.nextInt(256)));
                                     }
                                     //checking the vertical collision
                                     if(y-radius<0)
                                     {
                                         sy=-sy;
                                         y=radius;
                                         setColor(new Color(r.nextInt(256),r.nextInt(256),r.nextInt(256)));
                                     }
                                     else if(y+radius>win_h)
                                     {  
                                         sy=-sy;
                                         y=win_h-radius;
                                         setColor(new Color(r.nextInt(256),r.nextInt(256),r.nextInt(256)));
                                     }
                                     repaint();
                                     try
                                     {
                                         Thread.sleep(1000/update_rate);
                                     }
                                     catch(InterruptedException e)
                                     {
                                         JOptionPane.showMessageDialog(null,"Please don't interrupt me while sleeping !","Disturbed",JOptionPane.ERROR_MESSAGE);
                                     }
                                 }
                              }
                             };
         ballthread.start();//start the thread's execution    
    }
    
   
}